﻿using ProjectMotorboat.Entities;
using System.Diagnostics.CodeAnalysis;
namespace ProjectMotorboat.Drownings;

public class DrawningBoatEqutables : IEqualityComparer<DrawningBoat>
{
    public bool Equals(DrawningBoat? x, DrawningBoat? y)
    {
        if (x == null || x.EntityBoat == null)
        {
            return false;
        }

        if (y == null || y.EntityBoat == null)
        {
            return false;
        }

        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }

        if (x.EntityBoat.Speed != y.EntityBoat.Speed)
        {
            return false;
        }

        if (x.EntityBoat.Weight != y.EntityBoat.Weight)
        {
            return false;
        }

        if (x.EntityBoat.BodyColor != y.EntityBoat.BodyColor)
        {
            return false;
        }

        if (x is DrawningMotorboat && y is DrawningMotorboat)
        {
            EntityMotorboat EntityX = (EntityMotorboat)x.EntityBoat;
            EntityMotorboat EntityY = (EntityMotorboat)y.EntityBoat;

            if (EntityX.Glass != EntityY.Glass)
            {
                return false;
            }

            if (EntityX.Motor != EntityY.Motor)
            {
                return false;
            }

            if (EntityX.AdditionalColor != EntityY.AdditionalColor)
            {
                return false;
            }
        }
        return true;
    }

    public int GetHashCode([DisallowNull] DrawningBoat obj)
    {
        return obj.GetHashCode();
    }
}
