﻿using ProjectMotorboat.Entities;
namespace ProjectMotorboat.Drownings;

public class DrawningMotorboat : DrawningBoat
{ 
    public DrawningMotorboat(int speed, double weight, Color bodyColor, Color additionalColor, bool motor, bool glass) : base (160, 60)
    {
        EntityBoat = new EntityMotorboat(speed, weight, bodyColor, additionalColor, motor, glass);
        
    }

    public DrawningMotorboat(EntityMotorboat boat) : base(129, 80)
    {
        EntityBoat = new EntityMotorboat(boat.Speed, boat.Weight, boat.BodyColor, boat.AdditionalColor, boat.Motor, boat.Glass);
    }

    public override void DrawTransport(Graphics g)
    {
        if (EntityBoat == null || EntityBoat is not EntityMotorboat motorboat|| !_startPosX.HasValue || !_startPosY.HasValue)
        {
            return; 
        }

        Pen pen = new(Color.Black);
        Brush additionalBrush = new SolidBrush(motorboat.AdditionalColor);

        base.DrawTransport(g);
        if (motorboat.Glass)
        {
            Brush glassBrush = new SolidBrush(Color.LightBlue);
            g.FillEllipse(glassBrush, _startPosX.Value + 20, _startPosY.Value + 15, 100, 40);
            g.DrawEllipse(pen, _startPosX.Value + 20, _startPosY.Value + 15, 100, 40);
        }
        if (motorboat.Motor)
        {
            Brush engineBrush = new
            SolidBrush(motorboat.AdditionalColor);
            g.FillRectangle(engineBrush, _startPosX.Value + 0, _startPosY.Value + 10, 5, 50);
            g.DrawRectangle(pen, _startPosX.Value + 0, _startPosY.Value + 10, 5, 50);
        }
       
    }
}



